
// mobile_robot_Fast_slamDlg.cpp : implementation file
//

#include "stdafx.h"
#include "mobile_robot_RFID_PF.h"
#include "mobile_robot_RFID_PFDlg.h"

#include "mrs_rpc.h"
#include "mm.h"
#include "MatrixAlgebra.h"
#include "floor_landmark.h"
#include "diff_wheel_robot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


extern int rpc_client_init();
extern int rpc_client_free();


//  ȭ鿡  ġ m pixel ٲٱ    
#define SCREEN_OFFSET_X		50
#define SCREEN_OFFSET_Y		1100
#define SCREEN_SCALE		200

inline int M2Px(double x) { return (int)(SCREEN_OFFSET_X + x*SCREEN_SCALE); }
inline int M2Py(double y) { return (int)(SCREEN_OFFSET_Y - y*SCREEN_SCALE); }
inline int M2Pl(double l) { return (int)(l*SCREEN_SCALE); }


Cmobile_robot_RFID_PFDlg::Cmobile_robot_RFID_PFDlg(CWnd* pParent /*=NULL*/)
	: CDialog(Cmobile_robot_RFID_PFDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	_pf = NULL;
}

void Cmobile_robot_RFID_PFDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(Cmobile_robot_RFID_PFDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BT_RESET, &Cmobile_robot_RFID_PFDlg::OnBnClickedBtReset)
END_MESSAGE_MAP()


// Cmobile_robot_RFID_PFDlg message handlers

BOOL Cmobile_robot_RFID_PFDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
	rpc_client_init();

	load_floor_landmark (".\\map\\floor_landmark.txt");

	OnBnClickedBtReset();

	SetTimer (1000, 100, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void Cmobile_robot_RFID_PFDlg::OnTimer(UINT_PTR nIDEvent)
{
	unsigned long long detected_id = 0;
	
	double robot_x, robot_y, robot_theta;

	RpcTryExcept
	{
		//  ̵ оͼ κ ġ  Ѵ.
		double lm, rm;
		GetMotorPosition(&lm, &rm);
		
		double dlm = (lm-_plm)*_wheel_radius;
		double drm = (rm-_prm)*_wheel_radius;

		//  Ʈ  Ѵ.
		double sigma_wheel = 0.015;
		double sl = dlm + sigma_wheel*dlm*GaussRand ();
		double sr = drm + sigma_wheel*drm*GaussRand ();

		_pf->predict(sl, sr);

		_pf->statistical_pose ();

		_plm = lm; _prm = rm; 

		// νĵ RFID ± ID о´.
		unsigned long long fid[10] = {-1, -1, -1, -1, -1, -1, -1, -1, -1, -1 };
		GetFloorLandmark(fid);

		for (int i=0; i<10 && fid[i] != -1; ++i) {
			_pf->update(fid[i], 0.20);
			detected_id = fid[i];
		}

		// κ    ̵ ӵ Ѵ.
		static double leftMotor  = 3.0;
		static double rightMotor = 4.0;

		GoMotorVelocity (leftMotor+0.5*GaussRand (), rightMotor);

		// ùķͷκ κ  ġ о´.
		GetRobotPosition(&robot_x, &robot_y, &robot_theta);

		//  κ ġ RFID ±  ǥѴ.
		int n = 0;
		char buff[1024];
		sprintf (buff, "%g %g %g", robot_x, robot_y, robot_theta);
		SetDlgItemText (IDC_EDIT1, buff);

		n = 0;
		buff[0] = '\0';
		for (int i=0; i<10 && fid[i] != -1; ++i) {
			n += sprintf (buff+n, "%X", fid[i]);
		}
		SetDlgItemText (IDC_EDIT2, buff);
	}
	RpcExcept(1)
	{
		char text[1024];
		sprintf (text, "Runtime exception occured: %l \n", (long)RpcExceptionCode());
		TRACE (text);
	}
	RpcEndExcept

	if (_memDC.GetSafeHdc()) {
		DrawBackground (_memDC, 5, 5);
		DrawParticles (_memDC, _pf->_particles, RGB(0,0,255));
		DrawLandmark (_memDC, _floor_landmark, detected_id, RGB(192,192,192));
		DrawCross (_memDC, _pf->X(0,0), _pf->X(1,0), 0.3, RGB(255,0,255));
		DrawCovariance (_memDC, _pf->X(0,0), _pf->X(1,0), _pf->P(0,0), _pf->P(0,1), _pf->P(1,1), 2.);

		DrawRobot (_memDC, robot_x, robot_y, robot_theta, RGB(0,0,255));

		double robot_error = distance (_pf->X(0,0), _pf->X(1,0), robot_x, robot_y);

		char text[255];

		sprintf(text, "Number of Particles : %d", _pf->_particles.size());
		_memDC.TextOut(10, 10, text, strlen(text));

		sprintf(text, "Robot Position Error : %.3f", robot_error);
		_memDC.TextOut(10, 30, text, strlen(text));
	}

	InvalidateRect (&_memDCRect, FALSE);

	CDialog::OnTimer(nIDEvent);
}

void Cmobile_robot_RFID_PFDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	GoMotorVelocity (0, 0);

	if(_pf)	delete _pf;
	rpc_client_free();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void Cmobile_robot_RFID_PFDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this); // device context for painting

		if (_memDC.GetSafeHdc() == NULL) {
			GetClientRect (&_memDCRect);

			_memDC.CreateCompatibleDC(&dc);
			_bitmap.CreateCompatibleBitmap(&dc, _memDCRect.Width(), _memDCRect.Height());
			_bitmapOld = _memDC.SelectObject(&_bitmap);
			ASSERT (_bitmapOld);
		}

		if (_memDC.GetSafeHdc() != NULL) {
			dc.BitBlt(_memDCRect.left, _memDCRect.top, _memDCRect.Width(), _memDCRect.Height(), &_memDC, 0,0, SRCCOPY);
		}

		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR Cmobile_robot_RFID_PFDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void Cmobile_robot_RFID_PFDlg::DrawBackground (CDC &dc, int width, int height)
{
	dc.SelectStockObject (WHITE_PEN);
	dc.SelectStockObject (WHITE_BRUSH);

	dc.Rectangle (_memDCRect);

	CPen pen (PS_SOLID, 1, RGB(225,225,225));
	dc.SelectObject (pen);

	for (int i=0; i<=width; ++i) {
		dc.MoveTo (M2Px(i), M2Py(0));
		dc.LineTo (M2Px(i), M2Py(height));
	}
	for (int i=0; i<=height; ++i) {
		dc.MoveTo (M2Px(0), M2Py(i));
		dc.LineTo (M2Px(width), M2Py(i));
	}
}

void Cmobile_robot_RFID_PFDlg::DrawRobot (CDC &dc, double x, double y, double theta, COLORREF color)
{
	dc.SelectStockObject (NULL_BRUSH);

	CPen pen (PS_SOLID, 2, color);
	CPen pen2 (PS_SOLID, 2, RGB(255,255,0));

	dc.SelectObject (pen);

	int rx = M2Px(x);
	int ry = M2Py(y);
	int rr = M2Pl(_axle_length/2);

	int dx = (int)(rr*cos(theta));
	int dy = (int)(rr*sin(theta));

	dc.Ellipse (rx-rr, ry-rr, rx+rr, ry+rr);
	dc.MoveTo (rx, ry);
	dc.LineTo (rx+dx, ry-dy);
}

void Cmobile_robot_RFID_PFDlg::DrawParticles (CDC &dc, vector<sParticle> &particles, COLORREF color)
{
	for(unsigned int i = 0; i<particles.size(); i++) {
		dc.SetPixel(M2Px(particles[i].x), M2Py(particles[i].y), color);
	}
}

void Cmobile_robot_RFID_PFDlg::DrawLandmark (CDC &dc, map<unsigned long long, sFloorLandmark> &landmarks, unsigned long long detected_id, COLORREF color)
{
	dc.SelectStockObject (NULL_BRUSH);

	CPen pen (PS_SOLID, 1, color);
	CPen pen_red (PS_SOLID, 1, RGB(255,0,0));

	dc.SelectObject (pen);

	for (map<unsigned long long, sFloorLandmark>::iterator it = landmarks.begin(); it != landmarks.end(); it++) {
		sFloorLandmark &m = it->second;

		int x = M2Px(m.x);
		int y = M2Py(m.y);
		int r = M2Pl(m.r);

		dc.Ellipse(x - r, y - r, x + r, y + r);
	}

	if (detected_id) {
		dc.SelectObject (pen_red);

		sFloorLandmark *m = get_floor_landmark (detected_id);

		int x = M2Px(m->x);
		int y = M2Py(m->y);
		int r = M2Pl(m->r);

		dc.Ellipse(x - r, y - r, x + r, y + r);
	}
}

void Cmobile_robot_RFID_PFDlg::DrawCross (CDC &dc, double x, double y, double r, COLORREF color)
{
	dc.SelectStockObject (WHITE_BRUSH);

	CPen pen (PS_SOLID, 1, color);
	dc.SelectObject (pen);

	int rx = M2Px(x);
	int ry = M2Py(y);
	int rr = M2Pl(r);

	dc.MoveTo (rx, ry-rr);
	dc.LineTo (rx, ry+rr);

	dc.MoveTo (rx-rr, ry);
	dc.LineTo (rx+rr, ry);
}

void Cmobile_robot_RFID_PFDlg::DrawCovariance (CDC &dc, double x, double y, double s_xx, double s_xy, double s_yy, double mag)
{
	CPen pen (PS_SOLID, 1, RGB(255,0,0));
	dc.SelectObject (pen);

	dMatrix C(2,2);

	C(0,0) = s_xx;
	C(0,1) = C(1,0) = s_xy;
	C(1,1) = s_yy;

	dVector D;
	dMatrix V;

	if (C.eigen(D, V)) {
		for (unsigned int i = 0; i<D.size(); ++i) {
			D[i] = sqrt(D[i]);
		}

		for (unsigned int i=0; i<=360; i+=10) {
			double ri = _DEG2RAD*i;

			double ax = D[0]*cos(ri);
			double ay = D[1]*sin(ri);

			double rx = V(0,0)*ax + V(0,1)*ay;
			double ry = V(1,0)*ax + V(1,1)*ay;

			if(i==0) dc.MoveTo (M2Px(x + rx), M2Py(y + ry));
			else     dc.LineTo (M2Px(x + rx), M2Py(y + ry));
		}
	}
}

void Cmobile_robot_RFID_PFDlg::OnBnClickedBtReset()
{
	if (_pf) delete _pf;

	SetRobotPosition(2.5, 1.25, 0);
	
	_pf = new CParticleFilter();

	GetMotorPosition(&_plm, &_prm);
}
