
// mobile_robot_Fast_slamDlg.h : header file
//

#pragma once
#include "ParticleFilter.h"
#include "floor_landmark.h"

// Cmobile_robot_RFID_PFDlg dialog
class Cmobile_robot_RFID_PFDlg : public CDialog
{
// Construction
public:
	Cmobile_robot_RFID_PFDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_MOBILE_ROBOT_RFID_PF_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

private:
	void DrawBackground (CDC &dc, int width, int height);
	void DrawRobot (CDC &dc, double x, double y, double theta, COLORREF color);
	void DrawParticles (CDC &dc, vector<sParticle> &particles, COLORREF color);
	void DrawLandmark (CDC &dc, map<unsigned long long, sFloorLandmark> &landmarks, unsigned long long detected_id, COLORREF color);
	void DrawCross (CDC &dc, double x, double y, double r, COLORREF color);
	void DrawCovariance (CDC &dc, double x, double y, double s_xx, double s_xy, double s_yy, double mag);

	CRect    _memDCRect;
	CDC      _memDC;
	CBitmap  _bitmap;
	CBitmap* _bitmapOld;

	CParticleFilter* _pf;

	double _plm, _prm;

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedBtReset();
};
